<template>
  <section ref="parent">
    <h1>Maps</h1>

    <p>
      <label>
        map file:
        <select v-model="mapFilePath">
          <option
            v-for="file in mapFiles"
            :key="file"
            :value="`maps/${file}`"
            >{{ file }}</option
          >
        </select>
      </label>
    </p>
  </section>
</template>

<script>
import Game from '~/lib/game'
import MapScene from '~/lib/map-scene'

export default {
  props: {
    mapFiles: {
      type: Array,
      required: true
    }
  },

  data() {
    return {
      mapFilePath: null
    }
  },

  watch: {
    mapFilePath(newValue, oldValue) {
      const oldScene = this.game.scene.getScene(oldValue)
      if (oldScene) {
        this.game.scene.remove(oldScene)
      }

      const baseUrl = this.$router.options.base
      const scene = new MapScene(baseUrl, newValue)
      this.game.scene.add(null, scene, true)
    }
  },

  mounted() {
    const { parent } = this.$refs
    this.game = new Game({ parent })
  }
}
</script>
